<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Twitterアイコン変更ツール</title>
	
	<!-- jQueryライブラリ読み込み -->
	<script src="_js/jquery.js"
	type="text/javascript" charset="utf-8"></script>
	
	<script language="javascript">
	<!--
		function win_alert(mes){
			return confirm(mes) ;
		}
	//-->
	</script>

</head>
<body>

<h1>Twitterアイコン変更ツール</h1>

<?php
	require_once('setting.php');
	require_once('UltimateOAuth.php');
	
	$token = array(
		$consumer_key,
		$consumer_secret,
		$access_token,
		$access_token_secret
	);
	
	
	$mode     = true;  // トップへ戻るリンク用フラグ
	$change   = false; // 画像変更フラグ
		
	//とりあえず画像一覧を配列に作る
	$image_files  = glob( $folder_name . "*.{jpg,jpeg,gif,png}", GLOB_BRACE);
	natcasesort($image_files);
	
	//続いてフォルダ一覧を取得 一つ下の階層のみ
	$set = "";
	foreach (glob( $folder_name . "*") as $name) {
		if(strpos($name, ".") == false){
			$set .= str_replace($folder_name,'',$name) . "/";
		}
	}
	$folder_list  = explode("/", "/" . substr($set, 0,count($set)-2) );
	natcasesort($folder_list);
	
	
	
	//log.datファイルを読み込で、前回の画像を調べる
	$log      = "";
	$logName  = "log.dat";
	$fp       = fopen($logName, "r");
	while ($logfile = fgets($fp)) {
		$logdata    = preg_split('/,/', $logfile);
		$log        = $logdata[0];
		$olddate    = $logdata[1] . "月" . $logdata[2] . "日、" . $logdata[3] . "時" . $logdata[4] . "分";
		$AutoSwitch = $logdata[5];
		$radiSwitch = $logdata[6];
	}
	fclose($fp);
	
	
	// アイコン角丸の初期設定
	if(isset($_POST['onoff-btn']) ) {
		if(strpos($_POST['onoff-btn'] , 'アイコン自動変更') !== false){
			$button_data1 = 1;
		}else if(strpos($_POST['onoff-btn'] , 'アイコン角丸切り替え') !== false){
			$button_data1 = 0;
		}
		if(strpos($_POST['onoff-btn'] , 'ON') !== false){
			$button_data2 = 0;
		}else if(strpos($_POST['onoff-btn'] , 'OFF') !== false){
			$button_data2 = 1;
		}
		
		$AutoSwitch = ($button_data1 ? $button_data2 : $AutoSwitch);
		$radiSwitch = ($button_data1 ? $radiSwitch : $button_data2);
		$button_data3  = $logdata[0] . "," . $logdata[1] . "," . $logdata[2] . "," . $logdata[3] . "," . $logdata[4] . ",";
		$button_data3 .= $AutoSwitch . "," . $radiSwitch;
		
		$fp = fopen($logName, "w");
		fwrite($fp, $button_data3);
		fclose($fp);
	}
	
	echo "	<style type='text/css'>\n";
	echo "		img {\n";
	echo "			border: 1px #ffffff solid;\n";
	echo "			border-radius: "         . ($radiSwitch  ? $img_size/2 : 0) . "px;\n";
	echo "			-webkit-border-radius: " . ($radiSwitch  ? $img_size/2 : 0) . "px;\n";
	echo "			-moz-border-radius: "    . ($radiSwitch  ? $img_size/2 : 0) . "px;\n";
	echo "		}\n";
	echo "	</style>\n\n";
	
	// アイコン角丸のOnOff
	// apiモードの自動更新のOnOff
	echo "	<script type='text/javascript'>\n";
	echo "		onoff1 = " . ($AutoSwitch  ? "'on'" : "'off'") . ";\n";
	echo "		onoff2 = " . ($radiSwitch  ? "'on'" : "'off'") . ";\n\n";
	echo "		<!--\n";
	echo "		$(function() {\n";
	echo "			$('#onoff-btn1').click(function(){\n";
	echo "			switch (onoff1) {\n";
	echo "			case 'off':\n";
	echo "				onoff1 = 'on';\n";
	echo "			//	$('#onoff-txt1').text('ON');\n";
	echo "				break;\n";
	echo "			case 'on':\n";
	echo "				onoff1 = 'off';\n";
	echo "			//	$('#onoff-txt1').text('OFF');\n";
	echo "				break;\n";
	echo "			}\n";
	echo "			});\n\n";
	echo "			$('#onoff-btn2').click(function(){\n";
	echo "			switch (onoff2) {\n";
	echo "			case 'off':\n";
	echo "				onoff2 = 'on';\n";
	echo "			//	$('#onoff-txt2').text('ON');\n";
	echo "				$('img').stop().animate({borderRadius:' " . $img_size/2 . " '}, 20 );\n";
	echo "				break;\n";
	echo "			case 'on':\n";
	echo "				onoff2 = 'off';\n";
	echo "			//	$('#onoff-txt2').text('OFF');\n";
	echo "				$('img').stop().animate({borderRadius:'                   0 '}, 20 );\n";
	echo "				break;\n";
	echo "			}\n";
	echo "			});\n";
	echo "		});\n";
	echo "		-->\n";
	echo "	</script>\n\n\n";
	
	
	
	
	
	
	
	
	
	
	// URL引数でimage指定してある場合は引数の数値で変更
	// 画像番号のチェック 数値以外、配列の数の範囲外を入力されたらスルーする
	if ($_GET['mode'] == 'img'){
		if ( file_exists($_GET['imgname']) ){
			$img = $_GET['imgname'];
			echo "img番号指定モードで実行しました。<br /><br />";
			$change = true;
		}else{
			echo "その画像は存在しないよ。";
		}
	}
	
	// URL引数でapi指定してある場合は自動でランダム変更
	else if($_GET['mode'] == 'api'){
		if($AutoSwitch){
			//日付フォルダがあったらそこの中から選ぶ
			$set = $folder_name;
			foreach ($folder_list as $name){
				if($name != ""){
					$day = explode("_",$name);
					if($day[0] == 'xx'){
						$day[0] = date("y");
					}
					if($day[1] == 'xx'){
						$day[1] = date("n");
					}
					if($day[2] == 'xx'){
						$day[2] = date("j");
					}
					
					// フォルダが存在、かつ中に1ファイルでもあればOK
					if($day[0] == date("y") && $day[1] == date("n") && $day[2] == date("j")){
						$set = $folder_name . $name;
						
						$randam = glob( $set . '/' . "*.{jpg,jpeg,gif,png}", GLOB_BRACE);
						natcasesort($randam);
						
						if($randam[0] != ""){
							break;
						}
					}
				}
				$randam = glob( $folder_name . "*.{jpg,jpeg,gif,png}", GLOB_BRACE);
				natcasesort($randam);
			}
			
			while(1){
				$num = rand(0 , count($randam)-1 );
				$img = $randam[$num];
				
				//前回の画像ファイルパスと違っていればOK
				//フォルダに画像1枚しかなくて同じにならざるを得ない場合もOK
				if($img != $log || count($randam) == 1){
					break;
				}
			}
			echo "APIモードで実行しました。<br /><br />";
			$change = true;
		}else{
			echo "アイコン自動変更がOFFになってるので自動変更は行いませんでした。<br /><br />";
		}
	}
	
	// URL引数でアップロード指定してある場合は画像をアップする
	else if($_GET['mode'] == 'uplode'){
		if (is_uploaded_file($_FILES["upfile"]["tmp_name"])) {
			if (move_uploaded_file($_FILES["upfile"]["tmp_name"], $folder_name . $_FILES["upfile"]["name"])) {
				chmod("files/" . $_FILES["upfile"]["name"], 0644);
				
				echo "<table>\n";
				echo "	<tr><td>\n";
				echo $_FILES["upfile"]["name"] . "を<br />\n";
				echo $folder_name . "にアップロードしました。\n";
				echo "	</td><td>\n";
				echo "	<img src='" . $folder_name . $_FILES["upfile"]["name"] . "' height='" . $img_size . "px'></td></tr>\n";
				echo "</table><br />\n";
				
				//今回の画像の名前を持ってくる
				echo "<a href='?mode=img&imgname=" . $folder_name . $_FILES["upfile"]["name"] . "'>さっそく装備していくかい？</a>\n";
			} else if (file_exists($save_path)) {
				echo "同名のファイルがアップロードされています。";
			} else {
				echo "ファイルをアップロードできません。";
			}
		} else {
			echo "ファイルが選択されていません。";
		}
		echo "<br />\n";
	}
	
	// URL引数でデリート指定してある場合は指定番号の画像を削除する
	else if($_GET['mode'] == 'delete'){
		$img = $_GET['imgname'];
		echo str_replace($folder_name,'',$img) . "を削除しました。<br />";
		unlink($img);
	}
	
	else{
		$mode = false;
		echo "<table>\n";
		echo "	<tr>\n";
		if ( file_exists($log) ){
			echo "	<td>前回変更した画像<br />" . $log . "</td>\n";
			echo "	<td><img src='" . $log . "' height='" . $img_size . "px'></td>\n";
		}
		echo "	<td><a href='?mode=api' onclick='return win_alert(\"Twitterアイコンを変更しまか？\")'>ランダム変更する</a></td>\n";
		echo "	</tr>\n";
		echo "</table>前回は" . $olddate . "に変更しました。<br /><br />\n\n";
		
		echo "<form action='' method='post'>\n";
		echo "<div style='display: inline-block;'>\n";
		echo "	　<input id='onoff-btn1' type='submit' name='onoff-btn' value='アイコン自動変更" . ($AutoSwitch  ? 'ON' : 'OFF') . "' />\n";
	//	echo "	<a id='onoff-txt1'>" . ($AutoSwitch  ? 'ON' : 'OFF') . "</a>\n";
		echo "</div>\n";
		echo "<br /><br />\n";
		
		echo "<div style='display: inline-block;'>\n";
		echo "	　<input id='onoff-btn2' type='submit' name='onoff-btn' value='アイコン角丸切り替え" . ($radiSwitch  ? 'ON' : 'OFF') . "' />\n";
	//	echo "	<a id='onoff-txt2'>" . ($radiSwitch  ? 'ON' : 'OFF') . "</a>\n";
		echo "</div>\n";
		echo "<br /><br />\n";
		echo "</form>\n";
		
		
		
		// 画像アップローダ
		// セキュリティ上の取り扱いに要注意
		if($uplode_flg){
			echo "<div style='width:" . $List_size * ($img_size + 12) . "px'>\n";
			echo "<form action='?mode=uplode' method='post' enctype='multipart/form-data'>\n";
			echo "	<fieldset>\n";
			echo "		<legend>画像ファイルを選択(GIF, JPEG, PNGのみ対応)</legend>\n";
			echo "		<input type='file' name='upfile' accept='image/*' /><br />\n";
			echo "		<input type='submit' value='アップロード' />\n";
			echo "		\n";
			echo "		<div style='margin:5px 0px;' onclick='obj=document.getElementById(\"open\").style; obj.display=(obj.display==\"none\")?\"block\":\"none\";'>\n";
			echo "			<a style='cursor:pointer;border: solid 2px #808080;padding:2px 2px;'>▼ アップ時のルール</a>\n";
			echo "		</div>\n";
			echo "		<!--// 折り畳み展開ポインタ -->\n";
			echo "		<!-- 折り畳まれ部分 -->\n";
			echo "		<div id='open' style='display:none;clear:both;'>\n";
			echo "		┳┳アップロードする時はサーバーに置ける名前にしてね。<br />\n";
			echo "		┃┣┳使用可能なのは半角英数字と一部記号のみ。<br />\n";
			echo "		┃┃┣a～z、A～Z、0～9、<br />\n";
			echo "		┃┃┗「-(ハイフン)」「.(ピリオド)」「_(アンダーバー)」<br />\n";
			echo "		┃┗┳全角や日本語、スペース使用不可。<br />\n";
			echo "		┃　┣サイト管理してる人ならこの辺は大丈夫だろうけど一応表記。<br />\n";
			echo "		┃　┗ルール守らずにバグった場合のことは知らん。<br />\n";
			echo "		┗┳Twitterのアイコンの条件には気をつけてね。<br />\n";
			echo "		　┣━400x400がベースの大きさ。<br />\n";
			echo "		　┗┳GIF, JPEG, PNG形式のみOK。<br />\n";
			echo "		　　┣GIFはアニメーションが無くなる。<br />\n";
			echo "		　　┗PNGはTwitterが勝手にJPEGへ変換する。<br />\n";
			echo "		</div>\n";
			echo "		<!--// 折り畳まれ部分 -->\n";
			echo "	</fieldset>\n";
			echo "</form>\n";
			echo "</div>\n";
		}
	}
	
	// 画像変更実行
	if($change){
		echo date("n") . "月" . date("j") . "日、" . date("G") . "時" . date("i") . "分";
		echo " の実行結果です。<br /><br />";
		echo "<table>";
		echo "<tr><td>今回の画像<br />" . $img . "</td><td><img src='" . $img . "' height='" . $img_size . "px'></td></tr>";
		if ( file_exists($log) ){
		echo "<tr><td>変更前の画像<br />" . $log . "</td><td><img src='" . $log . "' height='" . $img_size . "px'></td></tr>";
		}
		echo "</table>前回は" . $olddate . "に変更しました。<br /><br />";
		
		$rc = new ReflectionClass('UltimateOAuth');
		$uo = $rc->newInstanceArgs($token);
		$res = $uo->post('account/update_profile_image', array(
			'@image' => $img
		));
		if (isset($res->errors)) {
			echo "エラーが発生しました。<br>" . $res->errors[0]->message;
		} else {
			echo "設定しました。";
		}
		echo "<br />";
		echo "<a href='https://twitter.com/" . $screen_name . "' target='_blank'>結果をTwitter公式で確認する</a><br>\n";
		
		// 今回設定したファイルをlogに記録する
		$fp = fopen($logName, "w");
		fwrite($fp, $img . "," . date("n") . "," . date("j") . "," . date("G") . "," . date("i") . "," . $AutoSwitch . $radiSwitch);
		fclose($fp);
	}
	
	if($mode){
		echo "<a href='" . strstr($_SERVER["REQUEST_URI"], '?', true) . "'>トップへ戻る</a><br>\n";
	}
	
	echo "<hr>\n";
	
		
	// 画像一覧の作成を実行
	echo "<table>\n";
	
	foreach ($folder_list as $name){
		//画像一覧の配列を作り直し
		if($name !== ""){
			$name .= "/";
		}
		$name = $folder_name . $name;
		$image_files = glob( $name . "*.{jpg,jpeg,gif,png}", GLOB_BRACE);
		natcasesort($image_files);
		
		// 画像が何も入ってないフォルダはスキップさせる
		if($image_files[0] != ""){
		
			echo "	<tr><td style='color:#ffffff;' bgcolor=#404040' rowspan='" . ceil( count($image_files) / $List_size) . "'>\n";
			echo $name . "</td>\n";
			
			$idx = 0;
			foreach ($image_files as $image) {
				if($idx % $List_size == 0){
					echo "	\n";
				}
					
				echo "		<td bgcolor=";
				
				// 横列と縦列が奇数同士or偶数同士
				// を基準にtdに色付け
				// ついでにアップロード直後は赤色で表示
				if($img == $image ){
					echo "#ff8080";
				}else if(
					($idx % $List_size) % 2
					== floor($idx / $List_size) % 2
				){
					echo "#dddddd";
				}else{
					echo "#cccccc";
				}
				echo ">\n";
				
				echo "			<div style='text-align: center;'>\n";
				echo "				<a href='?mode=img&imgname=" . $image . "' onclick='return win_alert(\"Twitterアイコンを変更しまか？\")'>\n";
				echo "				<img src=" . $image . " height='" . $img_size . "px' style='margin:5px;' class='border_radius'></a>\n";
				echo "			</div>\n";
				echo "			<div style='font-size:40%;\n";
				echo "				width: " . $img_size . "px;\n";
				echo "				white-space: nowrap;\n";
				echo "				overflow: hidden;\n";
				echo "				text-overflow: ellipsis;\n";
				echo "				-o-text-overflow: ellipsis;'>\n";
				echo "					" . str_replace($name,'',$image) . "\n";
				echo "			</div>\n";
				// echo $idx . " / " . $List_size;
				// サーバーから画像削除
				// セキュリティ上の取り扱いに要注意
				if($uplode_flg){
					echo "			<div style='font-size:40%;text-align: right;'>\n";
					echo "				<a href='?mode=delete&imgname=" . $image . "' onclick='return win_alert(\"" . str_replace($name,'',$image) . "を削除してよろしいですか？(元に戻せません！)\");'>\n";
					echo "				削除</a>\n";
					echo "			</div>\n";
				}
				
				echo "		</td>\n";
				if($idx % $List_size == $List_size - 1){
					echo "	</tr>\n";
				}
				$idx++;
			}
			if($idx % $List_size != $List_size - 1){
				echo "	</tr>\n";
			}
		}
	}
	echo "</table>";
	
	
	
	
?>

</body>
</html>
